package homework12;

public class TestDriver {
    
    private static final String vowels = "aeiou" ;
    private static final String consts = "bcdfghjklmnprstvwz" ;
    
    private static String genRandomString() {
        return ""
                + consts.charAt((int)(Math.random()*consts.length()))
                + vowels.charAt((int)(Math.random()*vowels.length()))
                + consts.charAt((int)(Math.random()*consts.length()))
                + vowels.charAt((int)(Math.random()*vowels.length())) ;
    }

    private static String[] generateArray(int size) {
        String[] returnMe = new String[size] ;
        for (int i=0; i<size; ++i) {
            returnMe[i] = genRandomString() ;
        }
        return returnMe ;
    }
    
    private static int countMatches(CSCI202Hash hash,
            String[] keys, String[] recs) {
        int matched = 0 ;
        for (int i = 0; i<keys.length; ++i) {
            String recOut = hash.retreive(keys[i]) ;
            if (recOut != null && recOut.equals(recs[i])) {
                ++matched ;
            }
        }
        return matched ;
    }
    
    private static void testHash(CSCI202Hash hash,
            String[] keys, String[] recs) {
        // Add 10000 key, record pairs
        // Expect around 5730 unique keys
        for (int i = 0; i<keys.length; ++i) {
            hash.insert(keys[i], recs[i]);
        }
        System.out.println("Matched " + countMatches(hash, keys, recs)
                + " of " + keys.length) ;
        
        // Remove half the keys
        for (int i = 0; i<keys.length; i+=2) {
            hash.delete(keys[i]);
        }
        // Should be around 2000
        System.out.println("Matched " + countMatches(hash, keys, recs)
                + " of " + keys.length) ;
    }
    
    public static void main(String[] args) {
        // with 5*18*5*18 or 8100 possibilities expect many duplicates
        String[] keys = generateArray(10000) ;
        String[] recs = generateArray(10000) ;
        System.out.println("Testing JCF based hash") ;
        testHash(new JCFHash(3499), keys, recs) ;
        
        /*
        System.out.println() ;
        System.out.println("Testing my hash") ;
        AprilHash hash = new AprilHash(3499) ;
        testHash(hash, keys, recs) ;
        */
    }

}
